#!/usr/bin/env python
# coding=utf8
#
# This file is part of PlayStream - enigma2 plugin to play video streams from various sources
# Copyright (c) 2016 ivars777 (ivars777@gmail.com)
# Distributed under the GNU GPL v3. For full terms see http://www.gnu.org/licenses/gpl-3.0.en.html
#
import os.path,re

os.path.dirname(os.path.abspath(__file__))
class Source(object):
    
    def __init__(self,country="lv"):
        self.name = "config"
        self.country=country
        self.lists = {}
        cur_directory = os.path.dirname(os.path.abspath(__file__))
        streams_file = os.path.join(cur_directory,"streams.cfg")
        for line in open(streams_file,"r"):
            r = re.search("\[(\w+)\]", line)
            if r:
                name = r.group(1)
                self.lists[name] = []
            else:
                if len(line)<10 or line[0] in ("#"): continue
                items = tuple(line.strip().split("|"))
                if len(items)<2:continue
                self.lists[name].append(items)        
        
    def get_content(self, data):
        if "::" in data:
            data = data.split("::")[1]
        if not data in self.lists:
            return []
        return self.lists[data]

    def is_video(self,data):
        return False
if __name__ == "__main__":
    c = Source()
    content = c.get_content("home")
    for item in content:
        print item
