#!/usr/bin/env python
# coding=utf8
#
# This file is part of PlayStream - enigma2 plugin to play video streams from various sources
# Copyright (c) 2016 ivars777 (ivars777@gmail.com)
# Distributed under the GNU GPL v3. For full terms see http://www.gnu.org/licenses/gpl-3.0.en.html
#
try:
    import json
except:
    import simplejson as json

import urllib2, urllib
import datetime, re, sys

API_URL = 'http://replay.lsm.lv/'
headers2dict = lambda  h: dict([l.strip().split(": ") for l in h.strip().splitlines()])
headers0 = headers2dict("""
User-Agent: Mozilla/5.0 (Linux; U; Android 4.4.4; Nexus 5 Build/KTU84P) AppleWebkit/534.30 (KHTML, like Gecko) Version/4.0 Mobile Safari/534.30
""")
import HTMLParser
h = HTMLParser.HTMLParser()
    
class Source(object):
    
    def __init__(self,country="lv"):
        self.name = "tvdom"
        self.country=country
        
    def get_content(self, data):
        print "[tvdom] get_content:", data
        if "::" in data:
            data = data.split("::")[1] 
        path = data.split("?")[0]
        clist = path.split("/")[0]
        params = data[data.find("?"):] if "?" in data else ""
        qs = dict(map(lambda x:x.split("="),re.findall("\w+=\w+",params)))
        lang = qs["lang"] if "lang" in qs else self.country
    
        content=[]
        content.append(("..return", "back","","Return back"))
        
        if clist=="home":
            content.extend([
                ("Live stream", "tvdom::tiesraides","","TV live streams"),
                ("Archive - categories", "tvdom::arhivs","","Video archive by categories"),
                #("Archive - all", "tvdom::arhivs_all","","Video archive all"),
             ])
            return content
  
        ### Tiesraides kanalu saraksts ###
        elif data=="tiesraides":
            ch_name = {"49":"Дом Кино","50":"Карусель","51":"Время","52":"Музыка Первого","53":"Телекафе"}
            url = "https://tvdom.tv/"
            r = self._http_request(url)
            for item in re.findall(r'<a class="channel-name">([^<]*)</a>.+?href="/tiesraides/(\d+)/.+?src="([^"]*)".*?<h3[^>]*>([^<]*)</h3>.*?<p class="unix">([^<]*)</p>', r, re.DOTALL):
                title = item[0]
                title =  h.unescape(title.decode("utf8")).encode("utf8")
                if not title:
                    title = ch_name[item[1]]
                img = "https://tvdom.tv"+item[2]
                data2 = "tiesraides/%s/"%item[1]
                desc = "%s\n%s\n%s"%(title,item[3],item[4])
                content.append((title,self.name+"::"+data2,img,desc))
            return content

        elif clist == "tiesraides":
            url = "https://tvdom.tv/" + data
            r = self._http_request(url)
            m = re.search("var streamConnectionUrl = '([^']+)'", r, re.DOTALL)
            if m:
                data2 = m.group(1)
            else:
                return ("No stream found %s"%data,"","","No stream found")
            m = re.search('title: "([^"]+)"', r, re.DOTALL)
            title = m.group(1) if m else data2
            m = re.search('<div id="panel">([^<]+)<', r, re.DOTALL)
            desc = m.group(1) if m else title
            m = re.search('<div id="panel">([^<]+)<', r, re.DOTALL)
            desc = m.group(1) if m else title 
            m = re.search('var promo_image *= "([^"]+)', r, re.DOTALL)
            img = m.group(1) if m else ""            
            return (title,data2,img,desc)

        ### Arhīva kategorijas ###
        elif data=="arhivs":
            url = "https://tvdom.tv/"+data
            r = self._http_request(url)
            for item in re.findall('pointer" href="/([^"]+)">([^<]+)</a>', r, re.DOTALL):
                title = item[1]
                title =  h.unescape(title.decode("utf8")).encode("utf8")
                img = ""
                data2 = item[0]
                desc = title
                content.append((title,self.name+"::"+data2,img,desc))
            return content

        ### Arhīva kategorijas programmas ###
        elif clist=="arhivs":
            url = "https://tvdom.tv/"+data
            r = self._http_request(url)
            for item in re.findall(r"""<li><div class="thumbnail pull-left" onclick="location\.href='/([^']+)'.+?data-content="([^"]*)".+?<img class="img-responsive" src="([^"]+)".+?<h3>([^<]+)</h3>.*?<h5></h5>.*?<p>([^<]+)</p>""", r, re.DOTALL):
                title = item[3] + " " + item[4]
                title =  h.unescape(title.decode("utf8")).encode("utf8")
                img = "https://tvdom.tv"+item[2]
                data2 = item[0]
                desc = item[1]
                content.append((title,self.name+"::"+data2,img,desc))
            return content

        ### Arhīva programmas video saraksts ###
        elif clist=="play_arhivs" and len(data.split("/"))==2:
            url = "https://tvdom.tv/"+data
            r = self._http_request(url)
            for item in re.findall('<div class="col-md-9 redirect-to-url same-event" data-href="/([^"]+)">.+?image" src="([^"]+)".+?<h3 class="same-title">([^<]+)</h3>.*?<h5 class="same-online">([^<]+)</h5>', r, re.DOTALL):
                title = item[2] + " " + item[3]
                title =  h.unescape(title.decode("utf8")).encode("utf8")
                img = "https://tvdom.tv"+item[1]
                data2 = item[0]
                desc = title
                content.append((title,self.name+"::"+data2,img,desc))
            return content
        
        ### Arhīva video
        elif clist=="play_arhivs" and len(data.split("/"))==3:
            url = "https://tvdom.tv/" + data
            r = self._http_request(url)
            m = re.search('var streamConnectionUrl  = "([^"]+)"', r, re.DOTALL)
            if m:
                data2 = m.group(1)
            else:
                return ("No stream found %s"%data,"","","No stream found")
            m = re.search('program_title        = "([^"]+)"', r, re.DOTALL)
            title = m.group(1) if m else data2
            m = re.search('<a class="episode">Pārraides laiks ēterā: <span>([^<]+)</span></a>', r, re.DOTALL)
            datums = m.group(1) if m else ""
            title = title + " " + datums
            m = re.search('<div id="panel">([^<]+)<', r, re.DOTALL)
            desc = m.group(1) if m else title
            m = re.search('<div id="panel">([^<]+)<', r, re.DOTALL)
            desc = m.group(1) if m else title 
            m = re.search('var share_image *= "([^"]+)', r, re.DOTALL)
            img = m.group(1) if m else ""            
            return (title,data2,img,desc)
               
    
    def is_video(self,data):
        if "::" in data:
            data = data.split("::")[1]
        cmd = data.split("/")
        if cmd[0] in ("tiesraides") and len(cmd)>1:
            return True
        elif cmd[0]=="play_arhivs" and len(cmd)==3:
            return True
        else:
            return False
    
    def call(self, data,headers=headers0,lang=""):
        if not lang: lang = self.country
        url = API_URL%lang + data
        #print "[TVPlay Api] url: ",url
        result = []
        content = self._http_request(url)
        return content

    def _http_request(self, url,headers=headers0):
        try:
            r = urllib2.Request(url, headers=headers)
            u = urllib2.urlopen(r)
            content = u.read()
            u.close()
            return content
        except Exception as ex:
            return None

if __name__ == "__main__":
    country= "lv"
    c = Source(country)
    if len(sys.argv)>1:
        data= sys.argv[1]
    else:
        data = "home"
    content = c.get_content(data)
    for item in content:
        print item
    #cat = api.get_categories(country)
    #chan = api.get_channels("lv")
    #prog = api.get_programs(channel=6400)
    #prog = api.get_programs(category=55)
    #seas = api.get_seasons(program=6453)
    #str = api.get_streams(660243)
    #res = api.get_videos(802)
    #formats = api.getAllFormats()
    #det = api.detailed("1516")
    #vid = api.getVideos("13170")
    pass